' FirefoxADM Shutdown 0.4
' 2004/2005 Mark Sammons


' create shell instance
set WshShell = WScript.CreateObject("WScript.Shell")

' create file object instances
set fso = CreateObject("Scripting.FileSystemObject")

' variables I'll be needing later
Const ForReading = 1, ForWriting = 2, ForAppending = 8
Dim FirefoxProfilePath, FirefoxPrefsFile, FirefoxProfileFolder, FirefoxProfiles
Dim FirefoxFolder, PrefsFile
Dim ParsePrefsFile, ParseOutPrefsFile
Dim FolderCreate, FirefoxProfileIniFile, FirefoxEmptyPrefsFile
' and this list needed for each feature
Dim HomePageKey, SearchEngineKey, ImageResizeKey, ProxyKey, ProxyURLKey
Dim HTTPKey, HTTPPortKey, SSLKey, SSLPortKey, FTPKey, FTPPortKey
Dim GopherKey, GopherPortKey, SOCKSKey, SOCKSPortKey, SOCKSVersionKey, ProxyExceptionsKey, ExceptionSplit
Dim FirefoxUseIEKey, IESettingFile, ParseFileLine, ParseSplitLine, ParseSplitSetting, SameProxy
Dim NetscapeJscFile, FirefoxJsFile

' define paths
set EnVar = Wshshell.environment("Process")
FirefoxPrefsFile = EnVar("ProgramFiles") & "\Mozilla Firefox\defaults\autoconfig\prefcalls.js"
NetscapeJscFile = EnVar("ProgramFiles") & "\Mozilla Firefox\netscape.jsc"
FirefoxJsFile = EnVar("ProgramFiles") & "\Mozilla Firefox\defaults\pref\firefox.js"

' Wipe out all settings
if fso.FileExists(FirefoxPrefsFile) = true then
	RemoveCurrentPrefsFromFile("browser.startup.homepage")
	RemoveCurrentPrefsFromFile("browser.enable_automatic_image_resizing")
	removeCurrentPrefsFromFile("network.proxy.type")
	removeCurrentPrefsFromFile("network.proxy.autoconfig_url")
	removeCurrentPrefsFromFile("network.proxy.http")
	removeCurrentPrefsFromFile("network.proxy.http_port")
	removeCurrentPrefsFromFile("network.proxy.ssl")
	removeCurrentPrefsFromFile("network.proxy.ssl_port")
	removeCurrentPrefsFromFile("network.proxy.ftp")
	removeCurrentPrefsFromFile("network.proxy.ftp_port")
	removeCurrentPrefsFromFile("network.proxy.gopher")
	removeCurrentPrefsFromFile("network.proxy.gopher_port")
	removeCurrentPrefsFromFile("network.proxy.socks")
	removeCurrentPrefsFromFile("network.proxy.socks_port")
	removeCurrentPrefsFromFile("network.proxy.socks_version")
	removeCurrentPrefsFromFile("network.proxy.no_proxies_on")
	RemoveCurrentPrefsFromFile("browser.cache.disk.capacity")
	RemoveCurrentPrefsFromFile("browser.cache.disk_cache_ssl")
	RemoveCurrentPrefsFromFile("browser.shell.checkDefaultBrowser")
	RemoveCurrentPrefsFromFile("xpinstall.enabled")
	RemoveCurrentPrefsFromFile("app.update.autoUpdateEnabled")
	RemoveCurrentPrefsFromFile("app.update.enabled")
	RemoveCurrentPrefsFromFile("security.enable_java")
	RemoveCurrentPrefsFromFile("javascript.enabled")
	RemoveCurrentPrefsFromFile("security.enable_ssl2")
	RemoveCurrentPrefsFromFile("security.enable_ssl3")
	RemoveCurrentPrefsFromFile("security.enable_tls")
	RemoveCurrentPrefsFromFile("network.enableIDN")
	RemoveCurrentPrefsFromFile("extensions.update.autoUpdateEnabled")
	RemoveCurrentPrefsFromFile("extensions.update.autoUpdate")
	RemoveCurrentPrefsFromFile("extensions.update.enabled")
	RemoveCurrentPrefsFromFile("accessibility.typeaheadfind")
	RemoveCurrentPrefsFromFile("signon.rememberSignons")
	RemoveCurrentPrefsFromFile("network.prefetch-next")
	RemoveCurrentPrefsFromFile("security.checkloaduri")
	RemoveCurrentPrefsFromFile("accessibility.browsewithcaret")
	RemoveCurrentPrefsFromFile("network.cookie.cookieBehavior")
	RemoveCurrentPrefsFromFile("network.cookie.lifetimePolicy")
	RemoveCurrentPrefsFromFile("network.cookie.lifetime.days")
end if




' TO DO:  More settings


Function RemoveCurrentPrefsFromFile(removeSetting)
	Set ParsePrefsFile = fso.OpenTextFile(FirefoxPrefsFile, ForReading)

	' Get file content into an array:
	Dim aContents
	aContents = Split(ParsePrefsFile.ReadAll, vbCrLf)

	ParsePrefsFile.Close
	set ParsePrefsFile = Nothing

	' Parse Back In to Prefs.js file

	Dim aContentsNew
	aContentsNew = Filter(aContents, chr(34) & removeSetting & chr(34), False, vbTextCompare)

	' Overwrite the old file with the new file,
  	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxPrefsFile, ForWriting)
  	ParseOutPrefsFile.Write Join(aContentsNew, vbCrLf)
    	ParseOutPrefsFile.Close
End Function

Function AppendPrefsToFile(writeKey, writeData)
	set PrefsFile = fso.OpenTextFile(FirefoxPrefsFile,ForAppending)
	PrefsFile.Write (vbCrLf & "lockPref(" & chr(34) & writeKey & chr(34) & ", " & writeData & ");")
	PrefsFile.Close
End Function